
{ IDirectDrawSurface Canvas subclass - Mike Scott 100140.2420@compuserve.com }

unit DDCanvas;

interface

uses Windows, SysUtils, Graphics, DDraw ;

type
  TDDCanvas = class( TCanvas )
  private
    FSurface       : IDirectDrawSurface ;
    FDeviceContext : HDC ;
  protected
    procedure CreateHandle ; override ;
  public
    constructor Create( ASurface : IDirectDrawSurface ) ;
    destructor Destroy ; override ;
    procedure Release ;
    function  DrawingAllowed : boolean ;
  end;

implementation

constructor TDDCanvas.Create( ASurface : IDirectDrawSurface ) ;

begin
  inherited Create ;
  if ASurface = NIL then
    Raise Exception.Create( 'Cannot create canvas for NIL surface' ) ;
  FSurface := ASurface ;
end ;


destructor TDDCanvas.Destroy ;

begin
  Release ;
  inherited Destroy ;
end ;


procedure TDDCanvas.CreateHandle ;

begin
  if FDeviceContext = 0 then begin
    FSurface.GetDC( FDeviceContext ) ;
    Handle := FDeviceContext ;
  end ;
end ;


procedure TDDCanvas.Release ;

begin
  if FDeviceContext <> 0 then begin
    Handle := 0 ;
    FSurface.ReleaseDC( FDeviceContext ) ;
    FDeviceContext := 0 ;
  end ;
end ;


function  TDDCanvas.DrawingAllowed : boolean ;

begin
  Result := FSurface.IsLost = DD_OK ;
end ;


end.
