unit MainUtDX;

interface

uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   DDraw, DDUtils, DDCanvas, DShow, DAnim, ComObj, Menus;

const
   MAX_X_LINE : Word = 320;
   MAX_Y_LINE : Word = 240;

   WIN_MOUSE_X_GAP   = 3;
   WIN_MOUSE_Y_GAP   = 24 + 17;

   BPP               : WORD = 1;

type

   TPixelFormat  = (pfUnknown, pfRGB8, pfRGB16, pfRGB15, pfBGR16, pfRGB24, pfBGR24, pfRGB32);

   TOption = record
      IsExclusive           : boolean; // Direct X     
      IsHighResolution      : boolean; // ػ  
      CanModifyWalkFrame    : boolean; // ǽð  Ű 
      CanDisplayPerformance : boolean; //  ս   
      UseSystemMemory       : boolean; // ý ޸𸮸 ۷ 
      IsRegistered          : boolean; //   Ǿ° ?
   end;

   TBasic = class(TForm)
    MainMenu1: TMainMenu;
    FileMemu: TMenuItem;
    FileOpen: TMenuItem;
    FileClose: TMenuItem;
    OpenDialog: TOpenDialog;
    FileN1: TMenuItem;
    FileStart: TMenuItem;
    FilePause: TMenuItem;
    FileN2: TMenuItem;
    FileExit: TMenuItem;
    TestMenu: TMenuItem;
    Test1: TMenuItem;
    Test2: TMenuItem;
    Test3: TMenuItem;

      procedure   DDFormCreate  (Sender: TObject);
      procedure   DDFormDestroy (Sender: TObject);
      procedure   DDFormShow    (Sender: TObject; IsExclusive : boolean);

      procedure   DShowCreate   (Sender: TObject; FileName : WideString);
      procedure   DShowDestroy  (Sender: TObject);

      procedure   FormCreate    (Sender: TObject);
      procedure   FormShow      (Sender: TObject);
      procedure   FormClose     (Sender: TObject; var Action: TCloseAction);
      procedure   FormDestroy   (Sender: TObject);
      procedure   FormMinimize  (Sender: TObject);
      procedure   FormOnRestore (Sender: TObject);
      procedure   FormKeyDown   (Sender: TObject; var Key: Word; Shift: TShiftState);
      procedure   FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
      procedure   FileOpenClick(Sender: TObject);
      procedure   FileCloseClick(Sender: TObject);
      procedure   FilePauseClick(Sender: TObject);
      procedure   FileStartClick(Sender: TObject);
      procedure   FileExitClick(Sender: TObject);
      procedure   Test1Click(Sender: TObject);
      procedure   Test2Click(Sender: TObject);
      procedure   Test3Click(Sender: TObject);

   private

      FPreviousFlipping : boolean;
      FFlippingEnabled  : boolean;
      FActive           : boolean;
      FIsFirstShow      : boolean;
      FCounter          : integer;

      PlayMovie         : Boolean;
      EnableCanvasTest  : Boolean;

      procedure   ExceptionHandler(Sender  : TObject; Error : Exception);
      procedure   HandleMessage   (var Msg : TMsg; var Handled : boolean);
      procedure   IdleHandler     (Sender  : TObject; var Done : boolean);
      function    GetBitmapName   (BitmapName : string; i : integer) : string;
      function    RestoreSurfaces : HResult;
      procedure   SetFlippingEnabled(Value : boolean);
      procedure   FlipPage;

   public

      FStartTickCount   : integer;              // īƮ ۽ Tick
      FFlippingCount    : integer;              //  ø ȸ

      PressedKey        : Word;

      FIsLocked         : boolean;
      PixelFormat       : TPixelFormat;
      Transparency      : DWORD;

      // Direct Draw
      DirectDraw        : IDirectDraw2;         // DirectDraw object  
      PrimarySurface    : IDirectDrawSurface;  //  ȭ 
      BackBuffer        : IDirectDrawSurface;  // ĸ 
      Clipper           : IDirectDrawClipper;   // Ŭ ü
      PrimaryCanvas     : TDDCanvas;
      BackCanvas        : TDDCanvas;            // ̹ 
      LockDesc          : TDDSurfaceDesc;      // Lock Suface Ÿ 

      DMMStream         : IMultiMediaStream;
      DDStreamSample    : IDirectDrawStreamSample;
      VideoSize         : TPoint;

      procedure   DrawScreen;
      procedure   UpdateDisplay(IsCommandable : boolean);
      function    MakeItSo     (DDResult : HResult) : boolean;
      property    FlippingEnabled : boolean read  FFlippingEnabled
                                            write SetFlippingEnabled;
      procedure   LockBackGround;
      procedure   UnlockBackGround;

      procedure   InitializeGame;
      procedure   FinalizeGame;

      procedure   ProcessMessages;
      procedure   WMActiveApp(var Msg : TWMActivateApp); message WM_ACTIVATEAPP;

   end;

var
   Basic          : TBasic;
   Option         : TOption;
   DebugString    : String = '';


implementation

{$R *.DFM}

const
   DD_ERROR_CONST = $88760000;


function    TBasic.GetBitmapName(BitmapName : string; i : integer) : string;
begin
   Result := {ExtractFilePath(Application.ExeName) + }BitmapName + IntToStr(i);// + '.BMP';
end;

procedure   TBasic.DDFormCreate(Sender: TObject);
begin
   FIsFirstShow      := TRUE;

   FIsLocked         := FALSE;
   FPreviousFlipping := FALSE;
   FFlippingEnabled  := FALSE;

   //  ڵ鷯 
   Application.OnException  := ExceptionHandler;
   Application.OnMinimize   := FormMinimize;
   Application.OnRestore    := FormOnRestore;

   Color       := clBlack;

   if Option.IsExclusive then begin
      BorderStyle := bsNone;
   end else begin
      SetBounds(0,0,MAX_X_LINE+WIN_MOUSE_X_GAP*2,MAX_Y_LINE+WIN_MOUSE_Y_GAP+5);
//      BorderStyle := bsSingle;
   end;
end;

procedure   TBasic.DDFormShow(Sender: TObject; IsExclusive : boolean);
var
   i             : integer;
   Test          : HRESULT;
   DirectDrawOld : IDirectDraw;
   DDSurfaceDesc : TDDSurfaceDesc;
   DDSCaps       : TDDSCaps;
   DDPixelFormat : TDDPixelFormat;
   ColorKey      : TDDColorKey;
   DC            : HDC;
begin
   if not FIsFirstShow then exit;

   FIsFirstShow := FALSE;

  { DD COM ü  }
   if DirectDrawCreate(nil,DirectDrawOld,nil) <> DD_OK then
      Raise Exception.Create('DirectDraw ü  ');

   if DirectDrawOld.QueryInterface(IDirectDraw2,DirectDraw) <> DD_OK then
      Raise Exception.Create('DirectDraw2 ü  ');

   DirectDrawOld := nil;

   if not Assigned(DirectDraw) then exit;

   if IsExclusive then begin

     { Ÿ Ǯũ Ȯ }
      Test := DirectDraw.SetCooperativeLevel(Handle,DDSCL_EXCLUSIVE or DDSCL_FULLSCREEN or DDSCL_ALLOWREBOOT);
      if Test <> DD_OK then
         Raise Exception.Create('Ÿ Ǯũ   : '+IntToStr(DWORD(Test)-DD_ERROR_CONST));

     { ȭ  ٲ }
      Test := DirectDraw.SetDisplayMode(MAX_X_LINE,MAX_Y_LINE,8*BPP,0,0);
      if Test <> DD_OK then
         Raise Exception.Create('320 x 240   : '+IntToStr(DWORD(Test)-DD_ERROR_CONST));

     { DirectDrawSurface ũ  }
      FillChar(DDSurfaceDesc,SizeOf(DDSurfaceDesc),0);
      with DDSurfaceDesc do begin
         dwSize            := SizeOf(DDSurfaceDesc);
         dwFlags           := DDSD_CAPS or DDSD_BACKBUFFERCOUNT;
         ddSCaps.dwCaps    := DDSCAPS_COMPLEX or DDSCAPS_FLIP or DDSCAPS_PRIMARYSURFACE;
         if Option.UseSystemMemory then
            ddSCaps.dwCaps := ddSCaps.dwCaps or DDSCAPS_SYSTEMMEMORY;
         dwBackBufferCount := 0;
      end;

     {  ȭ   }
      Test := DirectDraw.CreateSurface(DDSurfaceDesc,PrimarySurface,nil);
      if Test <> DD_OK then
         Raise Exception.Create(' ȭ    : '+IntToStr(DWORD(Test)-DD_ERROR_CONST));

   end else begin

     { Ϲ   }
      if DirectDraw.SetCooperativeLevel(Handle,DDSCL_NORMAL) <> DD_OK then
         Raise Exception.Create('Ϲ    ');

     { DirectDrawSurface ũ  }
      FillChar(DDSurfaceDesc,SizeOf(DDSurfaceDesc),0);
      with DDSurfaceDesc do begin
         dwSize            := SizeOf(DDSurfaceDesc);
         dwFlags           := DDSD_CAPS;
         ddSCaps.dwCaps    := DDSCAPS_PRIMARYSURFACE;
      end;

     {  ȭ   }
      if DirectDraw.CreateSurface(DDSurfaceDesc,PrimarySurface,nil) <> DD_OK then
         Raise Exception.Create(' ȭ   ');

      if DirectDraw.CreateClipper(0,Clipper,nil) <> DD_OK then
         Raise EXception.Create('Ŭ ü  ');

      if Clipper.SetHWnd(0,handle) <> DD_OK then
         Raise EXception.Create('Ŭ ü  ');

      if PrimarySurface.SetClipper(Clipper) <> DD_OK then
         Raise EXception.Create('Ŭ ǥ ߰ ');

   end;

  {  ȭ  TDDCanvases ü  }
   PrimaryCanvas  := TDDCanvas.Create(PrimarySurface);

  { ȼ  ǵ }
   FillChar(DDPixelFormat,sizeof(DDPixelFormat),0);
   DDPixelFormat.dwSize := sizeof(DDPixelFormat);
   if PrimarySurface.GetPixelFormat(DDPixelFormat) <> DD_OK then
      Raise Exception.Create('ȼ  б ');

   case BPP of

      1 :
      begin
         PixelFormat := pfRGB8;
      end;

      2 :
      begin
         if DDPixelFormat.dwRBitMask = $0000F800 then begin
            PixelFormat   := pfRGB16;
            Transparency  := $FFFF;
         end else if DDPixelFormat.dwRBitMask = $00007C00 then begin
            PixelFormat   := pfRGB15;
            Transparency  := $7FFF;
         end else if DDPixelFormat.dwRBitMask = $0000001F then begin
            PixelFormat   := pfBGR16;
            Transparency  := $FFFF;
         end else begin
            PixelFormat   := pfUnknown;
            Transparency  := $0000;
         end;
      end;

      3 :
      begin
         if DDPixelFormat.dwRBitMask = $00FF0000 then begin
            PixelFormat   := pfRGB24;
            Transparency := $FFFFFF;
         end else if DDPixelFormat.dwRBitMask = $000000FF then begin
            PixelFormat   := pfBGR24;
            Transparency := $FFFFFF;
         end else begin
            PixelFormat   := pfUnknown;
            Transparency := $000000;
         end;
      end;

      4 :
      begin
         PixelFormat   := pfRGB32;
         Transparency := $FFFFFF;
      end;

      else
      begin
         PixelFormat   := pfUnknown;
      end;

   end;

end;

procedure   TBasic.DShowCreate(Sender: TObject; FileName : WideString);
var
   DAMStream       : IAMMultiMediaStream;
   DDMStream       : IDirectDrawMediaStream;
   TempMediaStream : IMediaStream;
   DDSurfaceDesc   : TDDSurfaceDesc;
begin
   Pointer(DAMStream)       := nil;
   Pointer(DDMStream)       := nil;
   Pointer(TempMediaStream) := nil;

   BackCanvas               := nil;

   try
      DAMStream := IAMMultiMediaStream(CreateComObject(CLSID_AMMultiMediaStream));
      if not Assigned(DAMStream) then
         Exit;

      if DAMStream.Initialize(STREAMTYPE_READ, 0, nil) <> S_OK then
         Exit;

      if DAMStream.AddMediaStream(DirectDraw, MSPID_PrimaryVideo, 0, IMediaStream(nil^)) <> S_OK then
         Exit;

      //  üũ ʿ 
      DAMStream.AddMediaStream(nil, MSPID_PrimaryAudio, AMMSF_ADDDEFAULTRENDERER,IMediaStream(nil^));

      if DAMStream.OpenFile(PWideChar(FileName),0) <> S_OK then begin
         ShowMessage(' ã  ϴ : ' + FileName);
         Exit;
      end;

      DAMStream.QueryInterface(IID_IMultiMediaStream, DMMStream);

      if DMMStream.GetMediaStream(MSPID_PrimaryVideo, TempMediaStream) <> S_OK then
         Exit;

      if TempMediaStream.QueryInterface(IID_IDirectDrawMediaStream, DDMStream) <> S_OK then
         Exit;

      FillChar(DDSurfaceDesc, sizeof(DDSurfaceDesc), 0);
      DDSurfaceDesc.dwSize := Sizeof(DDSurfaceDesc);

      // ̵  ˻
      if DDMStream.GetFormat(TDDSurfaceDesc(nil^), IDirectDrawPalette(nil^), DDSurfaceDesc, DWord(nil^)) <> S_OK then begin
         ShowMessage(' ʴ ̵Դϴ.');
         Exit;
      end;

      VideoSize := Point(DDSurfaceDesc.dwWidth, DDSurfaceDesc.dwHeight);

      Basic.ClientWidth  := VideoSize.x;
      Basic.ClientHeight := VideoSize.y;

      DDSurfaceDesc.dwFlags := DDSurfaceDesc.dwFlags or DDSD_CAPS or DDSD_PIXELFORMAT;
      DDSurfaceDesc.ddsCaps.dwCaps := DDSurfaceDesc.ddsCaps.dwCaps or DDSCAPS_OFFSCREENPLAIN or DDSCAPS_SYSTEMMEMORY;

      if DirectDraw.CreateSurface(DDSurfaceDesc, BackBuffer, nil) <> S_OK then
         Exit;

      if DDMStream.CreateSample(BackBuffer, TRect(nil^), 0, DDStreamSample) <> S_OK then
         Exit;

      // Movie  Canvas 
      BackCanvas := TDDCanvas.Create(BackBuffer);

      with BackCanvas do try
         Font.Name   := 'Default';
         Font.Size   := 12;
         Font.Color  := clWhite;
         Font.Style  := [];
         Brush.Style := bsClear;
         Pen.Color   := RGB(0,255,100);
      finally
         Release;
      end;

      PlayMovie := TRUE;

   finally

      if Assigned(DAMStream) then
         DAMStream := nil;

      if Assigned(DDMStream) then
         DDMStream := nil;

      if Assigned(TempMediaStream) then
         TempMediaStream := nil;

      //   
      if not PlayMovie then begin
         if Assigned(DMMStream) then
            DMMStream := nil;

         if Assigned(DDStreamSample) then
            DDStreamSample := nil;

         if Assigned(BackCanvas) then begin
            BackCanvas.Free;
            BackCanvas := nil;
         end;
      end;

   end;
end;

procedure   TBasic.DShowDestroy(Sender: TObject);
begin
   BackCanvas.Free;
   BackCanvas := nil;

   DDStreamSample := nil;
   BackBuffer     := nil;
   DMMStream      := nil;
end;

procedure   TBasic.DDFormDestroy(Sender: TObject);
var
   i : integer;
begin
   UnlockBackGround;
  {  ø  }
   FlippingEnabled := FALSE;

  { ĵ ü  }
   PrimaryCanvas.Free;
   BackCanvas.Free;

  { ȭ   }
   if Assigned(PrimarySurface) then begin
      PrimarySurface := nil;
   end;

   if Option.IsExclusive then begin
      BackBuffer := nil;
   end else begin
      if Assigned(BackBuffer) then begin
         BackBuffer := nil;
      end;
   end;

   if Assigned(Clipper) then begin
      Clipper := nil;
   end;

  { DirectDraw COM ü  }
   if Assigned(DirectDraw) then begin
      DirectDraw := nil;
   end;

  {  ڵ鷯  }
   Application.OnException  := nil;
   Application.OnMinimize   := nil;
   Application.OnRestore    := nil;
   Application.OnActivate   := nil;
   Application.OnDeactivate := nil;

end;

procedure   TBasic.LockBackGround;
begin
   if not FIsLocked then begin
      LockDesc.dwSize := SizeOf(TDDSurfaceDesc);
      repeat
      until MakeItSo(BackBuffer.Lock(PRect(nil),LockDesc,DDLOCK_SURFACEMEMORYPTR +
                     DDLOCK_WAIT, 0));
      FIsLocked := TRUE;
   end;
end;

procedure   TBasic.UnlockBackGround;
begin
   if FIsLocked then begin
      BackBuffer.UnLock(LockDesc.lpSurface);
      FIsLocked := FALSE;
   end;
end;

procedure   TBasic.SetFlippingEnabled(Value : boolean);
begin
   if Value <> FFlippingEnabled then begin
      FFlippingEnabled := Value;
      if FFlippingEnabled then begin
        {  ̺Ʈ ڵ鷯 ġ }
//         Application.OnMessage := HandleMessage;
         Application.OnIdle    := IdleHandler;
      end else begin
        {  ̺Ʈ ڵ鷯  }
         Application.OnMessage := nil;
         Application.OnIdle    := nil;
      end;
   end;
end;

function    TBasic.MakeItSo(DDResult : HResult) : boolean;
begin
  { ȭ   Լ }
   case DDResult of
      DD_OK             : Result := TRUE;
      DDERR_SURFACELOST : Result := RestoreSurfaces <> DD_OK;
      else                Result := DDResult <> DDERR_WASSTILLDRAWING;
   end;
end;

function   TBasic.RestoreSurfaces : HResult;
begin
  { ȭ Ҿ MakeItSo ȣ }
   Result := PrimarySurface._Restore;
end;

procedure   TBasic.UpdateDisplay(IsCommandable : boolean);
begin
   if FActive or not Option.IsExclusive then DrawScreen;
end;

procedure   TBasic.HandleMessage(var Msg : TMsg; var Handled : boolean);
begin
   UpdateDisplay(TRUE);
end;

procedure   TBasic.IdleHandler(Sender : TObject; var Done : boolean);
begin
   UpdateDisplay(TRUE);
   Done := FALSE;
end;

(* WINDOW EVENT SECTION *)

procedure   TBasic.FormCreate(Sender: TObject);
begin

   if Option.IsHighResolution then begin
      MAX_X_LINE         := 640;
      MAX_Y_LINE         := 480;
   end else begin
      MAX_X_LINE         := 320;
      MAX_Y_LINE         := 240;
   end;

   FActive  := TRUE;
   FCounter := 1000;

   PlayMovie := FALSE;
   EnableCanvasTest := FALSE;

   DDFormCreate(Sender);
end;

procedure   TBasic.FormShow(Sender: TObject);
var
   i : integer;
begin
   DDFormShow(Sender,Option.IsExclusive);

   InitializeGame;

   for i := VK_LBUTTON to VK_SCROLL do begin
      GetAsyncKeyState(i);
   end;
end;

procedure   TBasic.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   BorderStyle := bsSingle;
end;

procedure   TBasic.FormDestroy(Sender: TObject);
begin
   FinalizeGame;

   DDFormDestroy(Sender);
end;

procedure   TBasic.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
   if Key = VK_F12 then Close;
   PressedKey := Key;
end;

procedure TBasic.FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   if Button = mbLeft  then PressedKey := VK_LBUTTON;
   if Button = mbRight then PressedKey := VK_RBUTTON;
end;

procedure   TBasic.FormMinimize(Sender: TObject);
begin
   FPreviousFlipping := FlippingEnabled;
   FlippingEnabled   := FALSE;
   WindowState       := wsMinimized;
end;

procedure   TBasic.FormOnRestore(Sender: TObject);
begin
   WindowState       := wsNormal;
   FlippingEnabled   := FPreviousFlipping;
   Basic.WindowState := wsNormal;
end;

procedure   TBasic.ExceptionHandler(Sender : TObject; Error : Exception);
var
   WasEnabled : boolean;
   WasLocked  : boolean;
begin
  {  ޼ ̱  GDI ȯ }
   MessageBeep(0);

   WasEnabled      := FlippingEnabled;
   FlippingEnabled := FALSE;

   WasLocked       := FIsLocked;
   if WasLocked then begin
      UnlockBackGround;
   end;

   if Assigned(DirectDraw) then DirectDraw.FlipToGDISurface;

   MessageDlg(Error.Message,mtError,[mbOK],0);

   if WasLocked then begin
      LockBackGround;
   end;

   FlippingEnabled := WasEnabled;

   Close;
end;

procedure   TBasic.ProcessMessages;
begin
   Application.ProcessMessages;
end;

procedure   TBasic.WMActiveApp(var Msg : TWMActivateApp);
begin
   FActive := Msg.Active;
   if FActive then begin
      FFlippingCount  := -50;
      FStartTickCount := GetTickCount;
      FlippingEnabled := TRUE;
   end else begin
      if Option.IsExclusive then begin
         FlippingEnabled := FALSE;
      end;
   end;

end;

var
   FlipPerSecond : Double;

procedure   TBasic.FlipPage;
const
   _COLOR_WHITE = $00FFFFFF;
var
   s        : string;
   Boundary : TRect;
   TimeGap  : Longint;
begin
   if Basic.FFlippingCount = 0 then begin
      Basic.FStartTickCount := GetTickCount;
   end;

   Inc(Basic.FFlippingCount);

   if Option.CanDisplayPerformance then
   if Basic.FFlippingCount > 0 then begin
      with Basic.BackCanvas do try
         if GetTickCount <> Basic.FStartTickCount then begin
            TimeGap := (GetTickCount-Basic.FStartTickCount);
            if TimeGap > 0 then FlipPerSecond := (Basic.FFlippingCount*1000) / TimeGap
                           else FlipPerSecond := 100;
            Str(FlipPerSecond : 5 : 2,s);
            TextOut(0,0,'FPS : '+s);
         end;
      finally
         Release;
      end;
   end;

   if Option.IsExclusive then begin
      with Basic do repeat
      until MakeItSo(PrimarySurface.Flip(nil,DDFLIP_WAIT));
   end else begin
      Basic.DirectDraw.WaitForVerticalBlank(DDWAITVB_BLOCKBEGIN,0);
      with Basic do repeat
         Boundary := Bounds(Left+WIN_MOUSE_X_GAP,Top+WIN_MOUSE_Y_GAP,MAX_X_LINE,MAX_Y_LINE);
      until MakeItSo(PrimarySurface.Blt(@Boundary,BackBuffer,PRect(nil),DDFLIP_WAIT,PDDBltFX(nil)));
   end;

end;

(* USER DEFINIION SECTION *)

procedure   TBasic.InitializeGame;
var
   Temp : Longint;
begin
   SystemParametersInfo(SPI_SCREENSAVERRUNNING, Word(TRUE), @Temp,0); // Disabled Ctrl-Alt-Del
end;

procedure   TBasic.FinalizeGame;
var
   Temp : Longint;
begin
   ClipCursor(nil);
   SystemParametersInfo(SPI_SCREENSAVERRUNNING, Word(FALSE), @Temp,0); // Enabled Ctrl-Alt-Del
end;

procedure   TBasic.DrawScreen;
var
   CurrentTime : TStream_Time;
begin
   Inc(FCounter);

   if PlayMovie then begin

      if DDStreamSample.Update(0, 0, nil, 0) <> S_OK then begin
         // Stop  
         Exit;
      end;

      DMMStream.GetTime(CurrentTime);
      DebugString := IntToStr(Trunc(CurrentTime / 10000000));

      try
         BackCanvas.TextOut(10, 10, PChar(DebugString + ' '));

         if EnableCanvasTest then begin
            BackCanvas.TextOut(Random(ClientWidth), Random(ClientHeight), ' Momoko ');
            BackCanvas.Pen.Color := RGB(Random(200) + 50, Random(200) + 50, Random(200) + 50);
            BackCanvas.MoveTo(Random(ClientWidth), Random(ClientHeight));
            BackCanvas.LineTo(Random(ClientWidth), Random(ClientHeight));
         end;

         PrimaryCanvas.CopyRect(Bounds(Left+WIN_MOUSE_X_GAP, Top+WIN_MOUSE_Y_GAP, ClientWidth, ClientHeight),
                                BackCanvas,
                                Bounds(0, 0, VideoSize.x, VideoSize.y));
      finally
         //  Canvas  ٸ κ.. ̰  
         PrimaryCanvas.Release;
         BackCanvas.Release;
      end;
   end;
end;

procedure TBasic.FileOpenClick(Sender: TObject);
begin
   if not PlayMovie then begin
      if OpenDialog.Execute then begin
         DShowCreate(Sender, OpenDialog.FileName);
         if PlayMovie then begin
            DMMStream.SetState(STREAMSTATE_RUN);
         end;
      end;
   end;
end;

procedure TBasic.FileCloseClick(Sender: TObject);
begin
   if PlayMovie then begin
      DMMStream.SetState(STREAMSTATE_STOP);
      PlayMovie := FALSE;
      DShowDestroy(Self);
   end;
end;

procedure TBasic.FileStartClick(Sender: TObject);
begin
   DMMStream.SetState(STREAMSTATE_RUN);
end;

procedure TBasic.FilePauseClick(Sender: TObject);
begin
   DMMStream.SetState(STREAMSTATE_STOP);
end;

procedure TBasic.FileExitClick(Sender: TObject);
begin
   Close;
end;

procedure TBasic.Test1Click(Sender: TObject);
var
   CurrentTime : TStream_Time;
begin
   DMMStream.GetTime(CurrentTime);
   DMMStream.Seek(CurrentTime + 20.0 * 10000000);
end;

procedure TBasic.Test2Click(Sender: TObject);
begin
   // ..  ũ ŵ
   DMMStream.Seek(30.0 * 10000000);
end;

procedure TBasic.Test3Click(Sender: TObject);
begin
   EnableCanvasTest := not EnableCanvasTest;
end;

Initialization

   with Option do begin
      IsExclusive           := not TRUE;
      IsHighResolution      := not TRUE;
      CanModifyWalkFrame    := not TRUE;
      CanDisplayPerformance := not TRUE;
      UseSystemMemory       := TRUE;
      IsRegistered          := not TRUE;
   end;   

end.

